<script>
    import { createEventDispatcher } from "svelte"
    import { slide } from "svelte/transition"
    import dayjs from "dayjs"

    const dispatch = createEventDispatcher()
    export let todo

    export let highlight
    let tokens = []

    let menuVisible = false

    $: isOverdue = dayjs(todo.due).isBefore(dayjs(), "day") && !todo.completed
    $: isDistant = dayjs(todo.due).isAfter(dayjs().add(6, "month"), "day")

    $: searchTerm = highlight.trim()
    $: searching = searchTerm.length > 0

    $: showDetails = (todo.due !== null)
        &&
        (
            dayjs(todo.due).isBefore(dayjs(), "day")
            ||
            dayjs(todo.due).isAfter(dayjs().add(1, "day"), "day")
        )

    function updateHighlight(searchTerm) {
        if (searching) {
            const index = todo.title.toLowerCase().indexOf(searchTerm.toLowerCase())

            if (index > -1) {
                const before = todo.title.slice(0, index)
                const token = todo.title.slice(index, index + searchTerm.length)
                const after = todo.title.slice(index + searchTerm.length)

                tokens = [
                    {text: before, highlight: false},
                    {text: token, highlight: true},
                    {text: after, highlight: false}
                ]
            } else {
                tokens = []
            }

            // const split = todo.title.toLowerCase().split(highlight.toLowerCase())
            // console.log(split)
            // tokens = split
            //     .flatMap(e => [{text: e, highlight: false}, {text: highlight, highlight: true}])
            //     .filter((e) => e.text.length > 0)
            //     .slice(0, -1)
            // console.log(tokens)
        } else {
            tokens = []
        }
    }

    $: updateHighlight(searchTerm)

    function handleSubmit(ev) {
        ev.preventDefault()
        dispatch("change", {todo: todo})
        menuVisible = false
        return false
    }

    function deleteTodo() {
        dispatch("delete", {todo: todo})
    }
</script>

<div class="card-content">
    <div class="is-flex is-align-items-center is-justify-content-space-between">
        <div class="field m-0">
            <input id={"todo_" + todo._id} class="is-checkradio" type="checkbox"
                   bind:checked={todo.completed}
                   on:change={handleSubmit}>
            <label for={"todo_" + todo._id}
                   class:has-text-grey-light={todo.completed}
                   class:has-text-grey-lighter={searching && tokens.length === 0}
                   class:completed={todo.completed}
                   style="width: 100%">
                {#if tokens.length > 0}
                    {#each tokens as token}
                        {#if token.highlight}
                            <span class="highlight">{token.text}</span>
                        {:else}
                            {token.text}
                        {/if}
                    {/each}
                {:else}
                    {todo.title}
                {/if}
            </label>
        </div>
            <i class="todo-menu fa-solid fa-ellipsis"
               class:active={menuVisible}
               on:click={() => menuVisible = !menuVisible}></i>
    </div>

    {#if showDetails && !menuVisible}
    <div class="is-size-7 mt-1"
         class:has-text-grey-light={!isOverdue}
         class:has-text-danger={isOverdue}>
        {#if isDistant}
            {dayjs(todo.due).format("MMM D, YYYY")}
        {:else}
            {dayjs(todo.due).format("MMM D")}
        {/if}
    </div>
    {/if}

    {#if menuVisible}
        <form class="mt-4" on:submit={handleSubmit} transition:slide>
            <div class="field">
                <label class="label">Title</label>
                <div class="control">
                    <input class="input is-small" type="text" bind:value={todo.title}>
                </div>
            </div>

            <div class="field">
                <label class="label">Due date</label>
                <div class="control">
                    <input class="input is-small" type="date" bind:value={todo.due}>
                </div>
            </div>

            <div class="is-flex is-justify-content-space-between">
                <button type="submit" class="button is-primary is-inverted">
                    <i class="fa-solid fa-check"></i>
                </button>
                <button type="button" class="button is-danger is-inverted"
                        on:click={deleteTodo}>
                    <i class="fa-solid fa-trash"></i>
                </button>
            </div>
        </form>
    {/if}
</div>

<style>
    .completed {
        text-decoration: line-through;
        transition: color 250ms ease;
    }

    .card-content {
        padding: 0.5rem 1rem;
    }

    .card-content .todo-menu {
        opacity: 0;
        transition: opacity 250ms ease;
    }

    .card-content:hover .todo-menu, .card-content .todo-menu.active  {
        opacity: 0.4;
    }

    .highlight {
        background-color: #FFF176;
    }
</style>